package clustering.stc;

import java.util.Set;

public class BaseCluster implements Comparable {

    public String label; //The processed label (as appearing in the tree)
    Set docIDs;
    public float score;
    public String[] labelString; //Needed to get the original label
    public int originOffset, originLength;
    public float coverage, odpboost, queryboost, b_length, f_of_p_length;

    public BaseCluster(String label, Object[] idsAndOrigin) {
        this.label = label;
        this.docIDs = (Set) idsAndOrigin[0];
        clustering.suffixtree.Node node = (clustering.suffixtree.Node) idsAndOrigin[1];
        int depth = ((Integer) idsAndOrigin[2]).intValue(); //Depth at which the node labels starts
        this.labelString = node.label;
        this.originOffset = node.labelOffset - depth;
        this.originLength = node.labelLength + depth;
    }

    public int compareTo(Object o) {
        //Compare similarity, if it's equal compare nofDocsInCluster
        BaseCluster bc = (BaseCluster) o;
        if (bc.score != this.score)
            return (int)(1000 * (bc.score - this.score));
        else
            return (int)(1000 * (bc.docIDs.size() - this.docIDs.size()));
    }

    public String toString() {
        return label + " [" + docIDs.size() + "]";
    }

}
