package clustering.stc;

import java.util.Set;
import java.io.Serializable;

public class Cluster implements Comparable, Serializable {

    public String label;
    public Set baseClusters;
    Set docIDs;
    int id;

    static int nextID = 0;

    public Cluster(String label, Set baseClusters) {
        this.label = label;
        this.baseClusters = baseClusters;
        this.id = nextID++;
    }

    public int getSize() {
        return docIDs.size();
    }

    public String getLabel() {
        return label;
    }

    public Set getDocIDs() {
        return docIDs;
    }

    public int getId() {
        return id;
    }

    public int compareTo(Object o) {
        //Largest clusters are highest ranked
        return ((Cluster) o).docIDs.size() - docIDs.size();
    }
}