package clustering.suffixtree;

import java.util.*;

public class LeafNode extends Node {

    // Contructs new leaf with label and engine given
    public LeafNode(String[] label, int offset, int length, Integer docID) {
        super(label, offset, length);
        indices.add(docID);
    }

    //Constructs new leaf from all tokens after labelOffset of the original and copies its indices
    public LeafNode(LeafNode old, int offset) {
        super(old.label, offset, old.label.length - offset);
        indices = old.indices;
    }

    //Constructs new leaf from all tokens after offset
    public LeafNode(String[] label, int offset) {
        super(label, offset, label.length - offset);
    }

    public void addString(String[] string, int offset, Integer docID) {
        indices.add(docID);
    }

}
