package clustering.suffixtree;

import clustering.suffixtree.InternalNode;

import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;

public abstract class Node {

    public String[] label; //Trenger egentlig ikke denne, kan ha stringMgr og bruke ints...
    public int labelOffset; //Nof tokens offset (acutal label is only part of the String[])
    public int labelLength; //Nof tokens in the label
    Set indices;

    protected Node(String[] label, int offset, int length) {
        this.label = label;
        this.labelOffset = offset;
        this.labelLength = length;
        indices = new HashSet();
    }

    public abstract void addString(String[] tokens, int offset, Integer docID);

    //Returns label from offset to offset+length as a string
    public String getLabel() {
        StringBuffer sb = new StringBuffer(label[labelOffset]);
        for (int i = labelOffset + 1; i < (labelOffset + labelLength); i++) {
            sb.append(" " + label[i]);
        }
        return sb.toString();
    }

    public String toString() {
        StringBuffer sb = new StringBuffer(getLabel());
        if (indices.size() > 0) {
            sb.append(" [");
            for (Iterator iterator = indices.iterator(); iterator.hasNext();) {
                sb.append(iterator.next() + " ");
            }
            sb.append(']');
        }
        if (this instanceof InternalNode)
            return "Int: " + sb.toString();
        else
            return "Lv: " + sb.toString();
    }

}
