package crawling.google;

import com.google.soap.search.*;

import java.io.*;

/**
 * Takes in a file of queries and saves the 10 first result urls from google
 */
public class GoogleQueryer {

    public static void main(String[] args) {
        int lookahead = 5;
        String clientKey = "45gcptNQFHJxQRy2Z2rG6qHraxYVk9TF";
        String fromFileName = "googlequeries.txt";
        String toFileName = "queryurls/jaguarcats.txt";
        BufferedReader br = null;
        BufferedWriter bw = null;

        try {
            br = new BufferedReader(new FileReader(fromFileName));
            bw = new BufferedWriter(new FileWriter(toFileName));
            for (int i = 0; i < lookahead; i++) {
                br.readLine();
            }
            String line = br.readLine();
            int startResult = 0;
            while (line != null && startResult < 1000) {
                try {
                    // Create a Google Search object, set our authorization key
                    GoogleSearch s = new GoogleSearch();
                    s.setKey(clientKey);
                    s.setQueryString(line);
                    s.setStartResult(startResult);
                    System.out.print("query: '" + line + "'. offset: " + startResult + ".");
                    GoogleSearchResult r = s.doSearch();
                    //Save results
                    //bw.write("###" + line + "\n");
                    GoogleSearchResultElement[] e = r.getResultElements();
                    for (int i = 0; i < e.length; i++) {
                        GoogleSearchResultElement googleSearchResultElement = e[i];
                        bw.write(googleSearchResultElement.getURL() + "\n");
                    }

                } catch (GoogleSearchFault f) {
                    System.out.println(" failed!");
                    try {
                        Thread.sleep(31000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    continue;
                }
                try {
                    Thread.sleep(5000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                System.out.println(" success!");
                startResult += 10; //Only advance if it was a success
                bw.flush();
            }
            br.close();
            bw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
