package crawling.google;

import tools.HtmlStripper;

import java.io.*;
import java.net.URL;

/**
 * Get urls from results of yahooqueries on google, and saves them i separate files
 */
public class GoogleResultMiner {

    static String tempFileName;

    public static void main(String[] args) {
        /*if (args.length < 2) {
            System.out.println("Usage: GoogleResultMiner <fromfilename> <lookahead>");
            System.exit(-1);
        }*/
        String query = "jaguarcats";
        String fromFileName = "queryurls/" + query + ".txt";
        //tempFileName = args[0] + "temp.txt";
        int lookahead = 800;//Integer.parseInt(args[1]);
        System.out.println("Syntax: '-': ok. 's': skipped. 'e': exists. 'f': failed. 'q': query.");

        BufferedReader br = null;
        BufferedWriter bw = null;

        try {
            br = new BufferedReader(new FileReader(fromFileName));

            //Skip first line
            br.readLine();

            //Lookahead:
            for (int i = 0; i < lookahead; i++) {
                br.readLine();
            }

            //Get urls:
            String line = null;
            int nof = lookahead;
            while ((line = br.readLine()) != null) {
                if (nof++ % 50 == 0)
                    System.out.print("\n" + (nof - 1) + ":\t");
                if (line.startsWith("###")) {
                    System.out.print("q");
                    continue; //Ignore queries...
                }
                if (line.endsWith(".pdf")) {
                    System.out.print("s"); //Skipped
                    continue; //Skip pfd-files
                }
                String filename = line.substring(line.indexOf(':') + 3, line.length());
                filename = filename.replaceAll("/", "#");
                filename = filename.replaceAll("\\?", "@");
                filename = filename.replaceAll("_", "");
                filename = filename.replaceAll(":", "_");
                if (filename.length() > 250)
                    filename = filename.substring(0, 250); //Trunc long names

                //litt mer sofistikert hashing.
                /*byte[] bytes = filename.getBytes();
                int hash = 0;
                for (int i = 0; i < bytes.length; i++) {
                    hash = (bytes[i] + hash) % 100;
                }
                filename = "docs/" + hash + "/" + filename + ".txt";*/
                filename = "collections/queries/" + query + "/" + filename + ".txt";

                File f = new File(filename);
                if (f.exists()) {
                    System.out.print("e"); //Exists
                    continue;
                }

                try { //Fr vi noe IOKrll bare skippes linjen...
                    bw = new BufferedWriter(new FileWriter(filename));

                    //String fileContents = HtmlStripper.readUrlAndStrip(line, tempFileName);
                    String fileContents = HtmlStripper.readAll(line, true);

                    //Restrict files to 100k.
                    //if (fileContents.length() > 100000)
                    //    fileContents = fileContents.substring(0, 100000);

                    //Saving file:
                    bw.write(fileContents);
                    bw.close();
                    System.out.print("-"); //Ok
                } catch (IOException e) {
                    System.out.print("f"); //Failed
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
