package crawling.querylog;

import tools.StopwordRemover;

import java.util.*;
import java.io.*;

import searching.Settings;
import crawling.odp.ODPCategoryMiner;

public class QueryLog {

    public static void main(String[] args) {
        QueryLog q = QueryLog.getInstance();
        System.out.println(q.map.size());
        /*int nof = 100;
        for (Iterator iterator = q.map.iterator(); iterator.hasNext();) {
            if (nof-- == 0)
                break;
            String s = (String) iterator.next();
            System.out.println(s);
        } */
    }

    private HashSet map;
    static StopwordRemover stopWordRemover = StopwordRemover.getInstance();

    public QueryLog(String filename, int approximateSize) {
        map = new HashSet(approximateSize);
        /*try {
            BufferedReader br = new BufferedReader(new FileReader(filename));
            String line;
            while ((line = br.readLine()) != null) {
                StringTokenizer st = new StringTokenizer(line);
                while (st.hasMoreTokens()) {
                    String token = st.nextToken();
                    token = token.replace('\"', ' ');
                    token = token.trim();
                    token = token.toLowerCase();
                    if (!stopWordRemover.isStopword(token))
                        map.add(token);
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        } */
        try {
            tokenizeFile(new File(filename));
            writeHashMapToDisk();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public boolean contains(String word) {
        return map.contains(word);
    }

    private static QueryLog instance = null;

    public static QueryLog getInstance() {
        if (instance == null)
            instance = new QueryLog("../diplomold/shoppingdata/queries/extra-querylog-filtered", 69000);
        return instance;
    }

    private void tokenizeFile(File file) throws Exception {
        BufferedReader in = new BufferedReader(new FileReader(file));
        StringBuffer sb = new StringBuffer();
        int val = in.read();
        while (val != -1) {
            if ((val >= 65 && val <= 90) || (val >= 97 && val <= 122)) {
                //Found part of a word (A-Z || a-z)
                sb.append((char) val);
            } else {
                //Found specialchar.
                //If len>1 make word
                if (sb.length() > 1) {
                    String word = sb.toString().toLowerCase();
                    if (!stopWordRemover.isStopword(word)) {
                        map.add(word);
                    }
                }
                //If chars in buffer then reset it
                if (sb.length() > 0)
                    sb = new StringBuffer();
            }

            val = in.read();
        }

        //Add last token (potentially)
        if (sb.length() > 1) {
            String word = sb.toString().toLowerCase();
            if (!stopWordRemover.isStopword(word)) {
                map.add(word);
            }
        }
    }

    private void writeHashMapToDisk() throws Exception {
        ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream("indices/querylog.dat"));
        oos.writeObject(map);
        oos.close();
    }
}
