package searching.dataobjects;

import java.io.Serializable;

/**
 * Represents a document in the engine managed by a DocumentManager
 */
public class Document implements Serializable {

    public final int docID;
    public final String filename;

    public String title; //Title and url are extracted from the file when loading the document manager
    public String url;
    public String snippet; //Snippets are assigned on-the-fly query time

    public Document(int docID, String filename) {
        this.docID = docID;
        this.filename = filename;
    }
}
