package searching.dataobjects;

import java.io.Serializable;

public class Result implements Comparable, Serializable {

    public Document document;
    public final float similarity;
    public final int docID;
    public final long filepointer;

    public Result(int docID, long filepointer, float similarity) {
        this.docID = docID;
        this.filepointer = filepointer;
        this.similarity = similarity;
    }

    public String getShortUrl() {
        String shortUrl = document.url;
        if (shortUrl.length() > 100)
            shortUrl = shortUrl.substring(0, 97) + "...";
        return shortUrl;
    }

    public String getUrl() {
        return document.url;
    }

    public String getTitle() {
        return document.title;
    }

    public int getDocID() {
        return document.docID;
    }

    public String getSnippet() {
        return document.snippet;
    }

    /**
     * Negativ hvis dette resultatet har hyere similarity enn o (s fr vi riktig ranking)
     */
    public int compareTo(Object o) {
        return (int) (1000.0 * (((Result) o).similarity - this.similarity));
    }
}
