package tools;

import java.io.*;
import java.net.URL;

public class HtmlStripper {
    public static void main3(String[] args) throws Exception {
        //strip("D:\\data\\skole\\diplom\\yahoo\\collections\\queries\\jaguar\\www.whatcar.com#news-article.aspx@NA=218177.txt", "hest.txt");
        //strip("hest2.txt", "hest.txt");
    }
    public static void main(String[] args) throws Exception {
        File folder = new File("collections/queries");
        File[] folders = folder.listFiles();
        String destDir = "collections/queriesStripped/";
        for (int i = 0; i < folders.length; i++) {
            File[] files = folders[i].listFiles();
            System.out.println("Stripping " + folders[i].getName());
            for (int j = 0; j < files.length; j++) {
                File file = files[j];
                String newFileName = file.getName();
                String filename = file.getPath();

                //litt mer sofistikert hashing.
                byte[] bytes = filename.getBytes();
                int hash = 0;
                for (int l = 0; l < bytes.length; l++) {
                    hash = (bytes[l] + hash) % 100;
                }
                newFileName = destDir + hash + "/" + newFileName;

                //Safety:
                if (newFileName.length() > 225)
                    newFileName = newFileName.substring(0, 225) + ".txt";

                strip(filename, newFileName);
            }
        }
    }

    public static void strip(String fromFile, String toFile) throws Exception {
        String[] contents = strip(fromFile, false);
        if (contents[0].equals("Untitled")) {
            System.out.println("Untitled " + fromFile);
            return; //Skip untitled files...
        }

        if (contents[0].length() >= contents[1].length()) {
            System.out.println("Short file " + fromFile);
            return; //Skip untitled files...
        }
        BufferedWriter bw = new BufferedWriter(new FileWriter(toFile));
        bw.write(contents[0] + ".\n" + contents[1]);
        bw.close();
    }

    public static String[] strip(String filenameOrUrl, boolean isUrl) throws Exception {
        String contents = readAll(filenameOrUrl, isUrl);
        String lowercaseContents = contents.toLowerCase();

        //Get title
        int start = lowercaseContents.indexOf("<title");
        start = lowercaseContents.indexOf('>', start + 1) + 1;
        int stop = lowercaseContents.indexOf("</title>", start);
        String title;
        if (start != -1 && stop != -1)
            title = contents.substring(start, stop); //Get the title from the original string
        else
            title = "Untitled";

        String text = contents;
        //Strip contents of special tags
        text = text.replaceAll("(?i)<hea[^>]+>.*?</head>", "");
        text = text.replaceAll("(?i)<scrip[^>]+>.*?</script>", "");
        text = text.replaceAll("(?i)<styl[^>]+>.*?</style>", "");
        text = text.replaceAll("<!--.*?-->", "");

        text = text.replaceAll("(?i)</a>", "."); //Make sure phrases don't span entire menus etc.
        text = text.replaceAll("(?i)<br>", "."); //Make sure phrases don't span entire menus etc.
        text = text.replaceAll("(?i)</option>", "."); //Make sure phrases don't span entire menus etc.
        text = text.replaceAll("<\\S[^>]*>", " "); //Remove HTML-markup
        text = text.replaceAll("&nbsp;", " ");
        text = text.replaceAll("\t", "");
        text = text.replaceAll("( )+", " "); //Trunc whitespaces
        return new String[] {title, text};
    }

    public static String readAll(String filenameOrUrl, boolean isUrl) throws Exception {
        Reader reader;
        if (isUrl)
            reader = new InputStreamReader(new URL(filenameOrUrl).openStream());
        else
            reader = new FileReader(filenameOrUrl);
        return readAll(reader);
    }

    private static String readAll(Reader reader) throws Exception {
        BufferedReader br = new BufferedReader(reader);
        String line;
        StringBuffer sb = new StringBuffer();
        while ((line = br.readLine()) != null)
            sb.append(line + ' ');
        return sb.toString();
    }
}
