package tools;

import java.util.HashSet;
import java.io.*;

public class StopwordRemover {

    private HashSet stopwords;
    private static StopwordRemover stopwordRemover;

    public static StopwordRemover getInstance() {
        if (stopwordRemover == null) {
            stopwordRemover = new StopwordRemover();
            stopwordRemover.addFile("D:/data/skole/diplom/yahoo/englishreferencewords.txt");
            stopwordRemover.addFile("D:/data/skole/diplom/yahoo/extrastopwords.txt");
        }
        return stopwordRemover;
    }

    private StopwordRemover() {
        //Private contructor to diallow constructing multiple stopwordremovers
        stopwords = new HashSet();
    }

    private void addFile(String filename) {
        BufferedReader reader;

        File file = new File(filename);
        try {
            reader = new BufferedReader(new FileReader(file));
            String line = reader.readLine();
            while (line != null) {
                line = line.trim();
                if (line.length() > 0)
                    stopwords.add(line);
                line = reader.readLine();
            }
            reader.close();
        } catch (IOException ioe) {
            System.out.println("############# Couldn't read stopword file at " + file.getAbsolutePath() + " #######");
        }

    }

    public boolean isStopword(String word) {
        return stopwords.contains(word);
    }
}